#!/bin/sh
#bu_VINRARUS 2019
LD_PRELOAD=
if [ "$1" != "0" ] 
then
    ${0%/*}/dash "$0" 0
    exit
fi
INTERVAL="$((3600*3))"
ZONE="+2"
z_lang="auto"
SED=1
W='"'
OLD=888
. ${0%/*}/Config.sh
LANGUST(){
if [ "$z_lang" = "auto" ]
then
    while read A B LANGS
    do
        if [ "$A" = "DefaultInputLang" ]
        then
            break
        fi
    done </ezxlocal/download/appwrite/setup/ezx_system.cfg
else
LANGS="$z_lang"
fi
if [ -f "${0%/*}/LANG/$LANGS.sh" ]
then
	export LANG="${0%/*}/LANG/$LANGS.sh"
else
	export LANG="${0%/*}/LANG/en-gb.sh"
	LANGS="en-gb"
fi
if [ ! -f "$LANG" ]
then
	showQ "LANG EROR!" "Not file: $LANG" 2
	exit
fi
OLDL="$z_lang"
}
LANGUST
. $LANG
if [ ! -d "${0%/*}/tmp" ]
then
    mkdir "${0%/*}/tmp"
    ${0%/*}/setting.sh START
    . ${0%/*}/Config.sh
fi
KOSTIL=1
for FILE in "${0%/*}/tmp/"*
do
    KOSTIL="$((KOSTIL+1))"
    read TAM < $FILE
    TUT="$TUT \"$TAM\""
done
eval showRadio "'zForecast 2.0'" "''" $TUT "\*$Lnastroy"
RADI=$?
if [ "$RADI" = 0 ]
then
    exit
elif [ "$RADI" = "$KOSTIL" ]
then
    echo setting
    ${0%/*}/dash ${0%/*}/setting.sh
    exit
fi
RAD=1
for FILE in "${0%/*}/tmp/"*
do
    if [ "$RADI" = "$RAD" ]
    then
        break
    else
        RAD=$((RAD+1))
    fi
done
CITY="${FILE##*/}"
CITY="${CITY%.*}"
POGODA="${0%/*}/tmp/$CITY.txt"
ZARAZ=`busybox date "+%Y.%m.%d %H"`
    TODI=
    TODI2=1
    ZARAZ2=2
if [ -f "$POGODA" ]
then
    TODI=`busybox date "+%Y.%m.%d %H:%M" -r "$POGODA"`
    TODI1=`busybox date "+%s" -r "$POGODA"`
    TODI2="$((TODI1+$INTERVAL))"
    ZARAZ2=`busybox date "+%s"`
fi
if [ 0 = "$INTERVAL" ]
then
    WAT(){
    showQ "zForecast" "$LupdateA" 1
    }
else
    WAT(){
    false
    }
fi
if [ ! -f "/ezxlocal/download/netexec" ]
then
    if ! showQ "zForecast EROR" "Netexec?" 0
    then
        exit
    fi
fi
if [ "${TODI%:*}" != "$ZARAZ" -a "$TODI2" -lt "$ZARAZ2" ]
then
    if WAT
    then
        showNotify "zForecast" "$Lauto" 1 1 &
    else
        if     `cat /ezxlocal/download/netexec` START
        then
            busybox wget "http://api.openweathermap.org/data/2.5/forecast?id=$CITY&appid=33fd99af62d7c1a27db28d3c6e442293&mode=xml&units=metric&lang=$LANGS" -O - > /tmp/zForecast.tmp
            echo >> /tmp/zForecast.tmp
            `cat /ezxlocal/download/netexec` stop -s &
            if [ ! -f "$POGODA" ]
            then
                mv "$FILE" "$POGODA"
            fi
            TODI1="$ZARAZ2"
       else 
            showNotify "zForecast" "$Lauto" 1 1 &
        fi
    fi
fi

CLEAR(){
read a b c d e f z < /dev/null
read A B C D E F G H Z < /dev/null
read DATA TIME POGODKA OPADN VITER VITERMS TEMPERATURA TNSK VOLOGIST HMARN TODI < /dev/null
}
SED1(){
N=1
NN=1
TEXT=
while read S1 S2 S3
do
if [ "$S1" = "-----" ]
then
    eval "$1=\"$S2\""
    eval "N$NN=\"$N\""
    TEN="$NN"
    eval "TEXT$TEN="
    NN=$(($NN+1))
    shift
else
eval "eval \"TEXT$TEN=\\\"\$TEXT$TEN $S1 $S2 $S3
\\\"\""
fi
N=$(($N+1))
done < $POGODA
}
SED2(){
N=0
NN=0
TEXT=
while read S1 S2 S3
do
N="$(($N+1))"
if [ "$S1" = "-----" ]
then
    N=1
TEXT="$TEXT$S1 $S2 $S3
"
elif [ "$N" = "2" ]
then
    TXT1="$S2"
    TXT3="$S3"
elif [ "$N" = "3" ]
then
    TXT2="$S1"
elif [ "$N" = "6" ]
then
    N=1
TEXT="$TEXT$TXT1 $TXT2 $TXT3
"
fi
done < $POGODA
}

PAR(){
NAM="$TAM"
YIM=0
VAL=
while [ "$NAM" != "$YIM" ]
do
    YIM="${NAM%%$W*}"
    NAM="${NAM#*$W}"
    if [ " $1=" = "$YIM" ]
    then
        YIM="${NAM%%$W*}"
        VAL="$YIM"
        break
    fi
done
}
SHIFT(){
DNI="${DNI#* }"
}
FILTER(){
DNI="$DAYS"
while read IN
do
STOP="${IN##*<}"
while [ "$OUT" != "$IN" ]
do
    OUT="${IN%%<*}"
    TAM=" ${OUT#* }"
    IN="${IN#*<}"
    case  "${OUT%% *}" in
    time) #датаТчас
        PAR from
        TIM="${VAL#*T0}"
        TIM="${TIM#*T}"
        TIM="${TIM%%:*}"
        TIME=$((ZONE+$TIM))
        if [ -z "$STARTDAY" ]
        then
            tY="${VAL%%-*}"
            tm="${VAL%-*}"
            tm="${tm#*-}"
            td="${VAL##*-}"
            td="${td%%T*}"
            tH="$TIM"
            tM="${VAL%:*}"
            tM="${tM##*:}"
            NOREAL=`busybox date -d "$tm $td $tH $tM $tY" +%w`
            if [ -z "$NOREAL" ]
            then
                STARTDAY=1
            else
                case "$TIME" in
                [0-9]|1[0-9]|2[0-3])
                    STARTDAY="$NOREAL"
                ;;
                -*)
                    if [ "$NOREAL" = 0 ]
                    then
                        STARTDAY=1
                    else
                        STARTDAY="$((NOREAL-1))"
                    fi
                ;;
                *)
                    if [ "$NOREAL" = 6 ]
                    then
                        STARTDAY=0
                    else
                        STARTDAY="$((NOREAL+1))"
                    fi
                ;;
                esac
            fi
        case "$STARTDAY" in
            1)
            SHIFT;
            ;;
            2)
            SHIFT; SHIFT;
            ;;
            3)
            SHIFT; SHIFT; SHIFT;
            ;;
            4)
            SHIFT; SHIFT; SHIFT; SHIFT;
            ;;
            5)
            SHIFT; SHIFT; SHIFT; SHIFT; SHIFT;
            ;;
            6)
            SHIFT; SHIFT; SHIFT; SHIFT; SHIFT; SHIFT;
            ;;
            0)
            SHIFT; SHIFT; SHIFT; SHIFT; SHIFT; SHIFT; SHIFT; 
            ;;
        esac
            DEN="${DNI%% *}"
            SHIFT
            if [ "$TIME" != 24 ]
            then
                echo "----- $DEN -----"
            fi
            #TIME=$(($ZONE+$TIM))
            OLD=0
        fi        
        case "$TIME" in
        2[4-9]|3[0-9])
            TIME=$(($TIME-24))
        ;;
        -*)
            TIME=$((24$TIME))
        ;;
        esac
        if [ "$TIME" -le "$OLD" ]
        then
            DEN="${DNI%% *}"
            SHIFT
            echo "----- $DEN -----"
        fi
        OLD="$TIME"
        DATA="$DEN"
   ;;
    symbol) #погода в принципі
        PAR name
        POGODKA="$VAL"
   ;;
    precipitation) #опади
        PAR type
        if [ -n "$VAL" ]
        then
            OPADN=", $Lprecipitation"
        fi
   ;;
    windDirection) #напрямок вітру
        PAR code
        VITER="$VAL"
   ;;
    windSpeed) #швидкість вітру
        PAR mps
        VITERMS="${VAL%.*} m/s"
   ;;
    temperature) #температура
        PAR value
        TEMPERATURA="${VAL%.*}°C"
   ;;
    pressure) #тиск
        PAR value
        TNSK="${VAL%.*} hPa"
   ;;
    humidity) #вологість
        PAR value
        VOLOGIST="$VAL%"
   ;;
    clouds) #стан хмар
        PAR all
        HMARN="$VAL%"
   ;;
    "/time>")
        TODI=$(($TIME+3))
        if [ "$TODI" -ge "24" ]
        then
            TODI=$(($TODI-24))
        fi
echo "$DATA $TIME: $POGODKA
$TEMPERATURA, $Lhumidity $VOLOGIST
$LwindSpeed $VITERMS ($VITER)
$Lclouds $HMARN$OPADN
"
        CLEAR
   ;;
    "name>"*)
        echo -n "${OUT#*>}"
   ;;
    "country>"*)
        echo ", ${OUT#*>}"
   ;;
    esac
done > $POGODA
done < /tmp/zForecast.tmp
rm -f /tmp/zForecast.tmp
}
SHOW1(){
if [ -n "$H" ]
then
    MOD=9
    TED="$A-$H"
elif [ -n "$G" ]
then
    MOD=8
    TED="$A-$G"
elif [ -n "$F" ]
then
    MOD=7
    TED="$A-$F"
elif [ -n "$E" ]
then
    MOD=6
    TED="$A-$E"
else
    MOD=10
    TED=
fi
read NAME < $POGODA
showRadio "$NAME" "$BLIN$TODI" $A $B $C $D $E $F $G $H "$TED"
RADIO=$?
if [ "$RADIO" = 0 ]
then
    exit
elif [ "$RADIO" = "$MOD" ]
then
    SED2
    SHOW2
else
    eval "DO=\$N$RADIO"
    eval "PISLYA=\$N$(($RADIO+1))"
    #showQ "zForecast" "`sed "1,${DO}d;$PISLYA,1000d" ${0%/*}/w3.txt`" 2
    eval "TEXT=\$TEXT$RADIO"
   if showQ "$NAME" "$TEXT$BLIN" 0
   then
    SHOW1
   fi
fi
}
SHOW2(){
read NAME < $POGODA
if showQ "$NAME" "$BLIN$TEXT$TODI" 0
then
    SED1 A B C D E F G H Z
    SHOW1
else
    exit
fi
}
if [ -f /tmp/zForecast.tmp ]
then
    FILTER $DAYS
elif [ ! -f "$POGODA" ]
then
    showQ "zForecast EROR" "$LupdateC" 2
    exit
else
    if [ "$((TODI1+440000))" -lt "$ZARAZ2" ]
    then
BLIN="$LupdateB
"
        if ! showQ "zForecast" "$LupdateB" 0
        then
            exit
        fi
    fi
fi
if [ "$SED" = "2" ]
then
    SED2
    SHOW2
else
    SED1 A B C D E F G H Z
    SHOW1
fi
